--- old/usr/src/lib/libdisasm/common/dis_s390x.c	2015-10-15 09:59:21.650347928 -0400
+++ new/usr/src/lib/libdisasm/common/dis_s390x.c	2015-10-15 09:59:21.654072644 -0400
@@ -2478,12 +2478,21 @@
 	[IF_SSF]	= fmt_ssf,
 };
 
-static int
+/*
+ * Even if we don't know how to disassemble the instruction, we know how long
+ * it is, so we always succeed.  That is why we can get away with returning
+ * void.
+ */
+static void
 dis_s390(uint64_t addr, union inst *inst, char *buf, size_t buflen, int mach)
 {
 	const struct inst_table *tbl = &tbl_xx[inst->raw[0]];
 	int tmp;
 
+	/* nothing to do */
+	if (buflen == 0)
+		return;
+
 	while (tbl->it_fmt == IF_TBL || tbl->it_fmt == IF_MULTI) {
 		if (tbl->it_fmt == IF_TBL) {
 			int idx;
@@ -2505,20 +2514,16 @@
 		goto inval;
 
 	tmp = snprintf(buf, buflen, "%-7s ", tbl->it_u.it_inst.it_name);
+	if (tmp < 0)
+		return;
 
 	fmt_fxns[tbl->it_fmt](addr, inst, buf + tmp, buflen - tmp,
 	    tbl->it_u.it_inst.it_flags);
 
-	return (0);
+	return;
 
 inval:
 	(void) snprintf(buf, buflen, "??");
-
-	/*
-	 * Even if we don't know how to disassemble the instruction, we know
-	 * how long it is, so we "succeed" even when we fail.
-	 */
-	return (0);
 }
 
 static int
@@ -2562,7 +2567,9 @@
 			break;
 	}
 
-	return (dis_s390(addr, &inst, buf, buflen, mach));
+	dis_s390(addr, &inst, buf, buflen, mach);
+
+	return (0);
 }
 
 /* ARGSUSED */
